#include "question.h"

QuestionEntity::QuestionEntity(int p_id, QString &p_question, QSet<QString>& p_answers, QStringList& p_variants):
    id(p_id), question(p_question), answers(p_answers), variants(p_variants) {}

int QuestionEntity::getId()
{
    return this->id;
}

QString QuestionEntity::getQuestion() const
{
    return this->question;
}

QSet<QString> QuestionEntity::getAnswers() const
{
    return this->answers;
}

QStringList QuestionEntity::getVariants() const
{
    return this->variants;
}

bool QuestionEntity::checkAnswers(const QSet<QString>& p_answers) const
{
    return this->answers == p_answers;
}

void QuestionEntity::setQuestion(QString &p_question)
{
    this->question = p_question;
}

void QuestionEntity::setAnswers(QSet<QString> &p_answers)
{
    this->answers = p_answers;
}
