#ifndef TESTER_H
#define TESTER_H

#include <QMainWindow>
#include "loginwidget.h"
#include "testselection.h"
#include "testentity.h"
#include "question.h"
#include <QtSql/QSqlDatabase>
#include <QtSql/QSqlQuery>
#include <QPushButton>
#include <QVector>


QT_BEGIN_NAMESPACE
namespace Ui { class Tester; }
QT_END_NAMESPACE

class Tester : public QMainWindow
{
    Q_OBJECT

public:
    int counter = 0;
    int questCount;
    Tester(QWidget *parent = nullptr);
    ~Tester();
    void drawCurrentQuestion(const QuestionEntity& currentQuestion);

public slots:
    void receiveNameAndPassword();
    void receiveTestEntity();
    void startExecution();
    void getAnswerFromLineEdit();

protected:
    QSqlDatabase db;
    QSqlQuery query;

private:
    Ui::Tester *ui;
    QString currentName;
    QString currentPassword;

    TestEntity* currentTest;

    TestSelection* testSelectionWidget;
    LoginWidget* loginWidget;

    QVector<QSet<QString>> currentAnswers;

signals:
    void onDataReceived();

};
#endif // TESTER_H
