#include "testselection.h"
#include "question.h"
#include <QSqlRecord>
#include <QSqlQueryModel>
#include <QDebug>

TestSelection::TestSelection(QWidget *parent) : QWidget(parent)
{
       mainLayout = new QVBoxLayout(this);
       db = QSqlDatabase::addDatabase("QPSQL");
       db.setHostName("195.19.32.74");
       db.setDatabaseName("fn1132_2020");
       db.setPort(5432);
       db.setUserName("student");
       db.setPassword("bmstu");
       db.open();
       QSqlQueryModel* sqlModel = new QSqlQueryModel(this);
       sqlModel->setQuery(QSqlQuery("SELECT name FROM tests;", db));
       int nameCount = sqlModel->rowCount();
       QList<QString> listNames;
       for (int i =0; i < nameCount; ++i) {
            listNames.push_back(sqlModel->index(i,0).data().toString());
            qDebug() << sqlModel->index(i,0).data().toString();
       }
       QVector<QPushButton*> btns;

       for (auto & qvar: listNames)
       {
           QPushButton *curr_btn = new QPushButton(qvar);
           connect(curr_btn, &QPushButton::clicked, this, &TestSelection::onButtonClicked);
           connect(curr_btn, &QPushButton::clicked, this, &TestSelection::close);
           btns.push_back(curr_btn);
       }

       for(auto & btn: btns)
       {
           mainLayout->addWidget(btn);
       }

       this->setLayout(mainLayout);

}

TestEntity *TestSelection::getTestEntity()
{
    return this->selectedTest;
}

void TestSelection::_sh()
{
    this->show();
}

void TestSelection::onButtonClicked()
{
    QPushButton* btn = dynamic_cast<QPushButton*>(sender());
    QString testName = btn->text();

    QSqlQueryModel* sqlModel = new QSqlQueryModel(this);
    sqlModel->setQuery(QSqlQuery("SELECT * FROM tests WHERE (name='" + testName + "');", db));

    int id = sqlModel->index(0,0).data().toInt();
    qDebug() << id;
    qDebug() << sqlModel->index(0,0).data();

    TestEntity* newTest = new TestEntity();
    newTest->setId(id);
    newTest->setName(testName);

    sqlModel->setQuery(QSqlQuery("SELECT * FROM test_questions WHERE (test_id=" + QString::number(newTest->getId()) + ");", db));

    QVector<QuestionEntity> questions;

    for(int i = 0; i < sqlModel->rowCount(); i++) {
        int id = sqlModel->index(i, 0).data().toInt();
        QString question = sqlModel->index(i, 1).data().toString();
        QStringList variantsList = sqlModel->index(i, 2).data().toString().split("%");
        QStringList answersList = sqlModel->index(i, 3).data().toString().split(" ");
        QSet<QString> answers(answersList.begin(), answersList.end());
        QuestionEntity qe(id,question,answers,variantsList);

        questions.push_back(qe);
    }

    newTest->setQuestions(questions);

    selectedTest = newTest;


    emit(onClosed());
}
